"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@nbsh/core");
const to_type_1 = require("@nbsh/to-type");
class PSBoolean extends core_1.SHObject {
    toString() {
        return this.value ? '$True' : '$False';
    }
}
exports.PSBoolean = PSBoolean;
class PSCustomObject extends core_1.SCustomObject {
    toString() {
        return `@${super.toString().replace(/:/g, '=').replace(/,/g, ';')}`;
    }
}
exports.PSCustomObject = PSCustomObject;
class PSArray extends core_1.SArray {
    toString() {
        return this.value.map((el) => core_1.convertTo(el, exports.PS_TYPES_MAP).toString()).join(',');
    }
}
exports.PSArray = PSArray;
class PSDate extends core_1.SHObject {
    toString() {
        return this.value.toLocaleString();
    }
}
exports.PSDate = PSDate;
class PSNull extends core_1.SNull {
    toString() {
        return '$Null';
    }
}
exports.PSNull = PSNull;
class PSError extends core_1.SHObject {
}
exports.PSError = PSError;
exports.PS_TYPES_MAP = {
    [to_type_1.Types.Boolean]: PSBoolean,
    [to_type_1.Types.Object]: PSCustomObject,
    [to_type_1.Types.Array]: PSArray,
    [to_type_1.Types.Date]: PSDate,
    [to_type_1.Types.Null]: PSNull,
    [to_type_1.Types.Error]: PSError,
};
//# sourceMappingURL=PSTypeConverter.js.map